P1: Progs/buy_example_pred.pl
1. holds(true,A).
2. holds(and(A,B),C) :- holds(A,C), holds(B,C).
3. holds(not(A),B) :- \+holds(A,B).
4. holds(A,[B|C]) :- elem(A), event(B), initiates(B,A), happens(B,C).
5. holds(A,[B|C]) :- elem(A), event(B), \+terminates(B,A), happens(B,C), 
          holds(A,C).
6. happens(buy(A,B),C).
7. happens(play1(A,B),C) :- holds(bought(A,B),C), holds(not(played1(A,B)),C).
8. happens(play2(A,B),C) :- holds(played1(A,B),C), holds(not(played2(A,B)),C).
9. elem(bought(A,B)).
10. elem(played1(A,B)).
11. elem(played2(A,B)).
12. event(buy(A,B)).
13. event(play1(A,B)).
14. event(play2(A,B)).
15. initiates(buy(A,B),bought(A,B)).
16. initiates(play1(A,B),played1(A,B)).
17. initiates(play2(A,B),played2(A,B)).
18. terminates(buy(A,B),played1(A,B)).
19. terminates(play1(A,B),played2(A,B)).
20. terminates(play2(A,B),bought(A,B)).
21. holds_played2(A,B,C) :- holds(played2(A,B),C).

P2: by unfolding cl 21 in P1 wrt atom 1 using P1

22. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          initiates(C,played2(A,B)), happens(C,D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P3: by unfolding cl 22 in P2 wrt atom 1 using P1

24. holds_played2(A,B,[C|D]) :- event(C), initiates(C,played2(A,B)), 
          happens(C,D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P4: by unfolding cl 24 in P3 wrt atom 1 using P1

25. holds_played2(A,B,[buy(C,D)|E]) :- initiates(buy(C,D),played2(A,B)), 
          happens(buy(C,D),E).
26. holds_played2(A,B,[play1(C,D)|E]) :- initiates(play1(C,D),played2(A,B)), 
          happens(play1(C,D),E).
27. holds_played2(A,B,[play2(C,D)|E]) :- initiates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P5: by deleting cl 25 in P4

26. holds_played2(A,B,[play1(C,D)|E]) :- initiates(play1(C,D),played2(A,B)), 
          happens(play1(C,D),E).
27. holds_played2(A,B,[play2(C,D)|E]) :- initiates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P6: by deleting cl 26 in P5

27. holds_played2(A,B,[play2(C,D)|E]) :- initiates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P7: by unfolding cl 27 in P6 wrt atom 1 using P1

28. holds_played2(A,B,[play2(A,B)|C]) :- happens(play2(A,B),C).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P8: by unfolding cl 28 in P7 wrt atom 1 using P1

29. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          holds(not(played2(A,B)),C).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P9: by unfolding cl 29 in P8 wrt atom 2 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
31. holds_played2(A,B,[play2(A,B),C|D]) :- holds(played1(A,B),[C|D]), 
          elem(not(played2(A,B))), event(C), initiates(C,not(played2(A,B))), 
          happens(C,D).
32. holds_played2(A,B,[play2(A,B),C|D]) :- holds(played1(A,B),[C|D]), 
          elem(not(played2(A,B))), event(C), \+terminates(C,not(played2(A,B))), 
          happens(C,D), holds(not(played2(A,B)),D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P10: by deleting cl 31 in P9

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
32. holds_played2(A,B,[play2(A,B),C|D]) :- holds(played1(A,B),[C|D]), 
          elem(not(played2(A,B))), event(C), \+terminates(C,not(played2(A,B))), 
          happens(C,D), holds(not(played2(A,B)),D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P11: by unfolding cl 32 in P10 wrt atom 1 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
33. holds_played2(A,B,[play2(A,B),C|D]) :- elem(played1(A,B)), event(C), 
          initiates(C,played1(A,B)), happens(C,D), elem(not(played2(A,B))), 
          event(C), \+terminates(C,not(played2(A,B))), happens(C,D), 
          holds(not(played2(A,B)),D).
34. holds_played2(A,B,[play2(A,B),C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D), 
          elem(not(played2(A,B))), event(C), \+terminates(C,not(played2(A,B))), 
          happens(C,D), holds(not(played2(A,B)),D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P12: by deleting cl 33 in P11

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
34. holds_played2(A,B,[play2(A,B),C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D), 
          elem(not(played2(A,B))), event(C), \+terminates(C,not(played2(A,B))), 
          happens(C,D), holds(not(played2(A,B)),D).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P13: by deleting cl 34 in P12

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
23. holds_played2(A,B,[C|D]) :- elem(played2(A,B)), event(C), 
          \+terminates(C,played2(A,B)), happens(C,D), holds(played2(A,B),D).

P14: by unfolding cl 23 in P13 wrt atom 1 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
35. holds_played2(A,B,[C|D]) :- event(C), \+terminates(C,played2(A,B)), 
          happens(C,D), holds(played2(A,B),D).

P15: by unfolding cl 35 in P14 wrt atom 1 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
36. holds_played2(A,B,[buy(C,D)|E]) :- \+terminates(buy(C,D),played2(A,B)), 
          happens(buy(C,D),E), holds(played2(A,B),E).
37. holds_played2(A,B,[play1(C,D)|E]) :- \+terminates(play1(C,D),played2(A,B)), 
          happens(play1(C,D),E), holds(played2(A,B),E).
38. holds_played2(A,B,[play2(C,D)|E]) :- \+terminates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E), holds(played2(A,B),E).

P16: by deleting goal [1] in cl 36 in P15

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
39. holds_played2(A,B,[buy(C,D)|E]) :- happens(buy(C,D),E), 
          holds(played2(A,B),E).
37. holds_played2(A,B,[play1(C,D)|E]) :- \+terminates(play1(C,D),played2(A,B)), 
          happens(play1(C,D),E), holds(played2(A,B),E).
38. holds_played2(A,B,[play2(C,D)|E]) :- \+terminates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E), holds(played2(A,B),E).

P17: by unfolding cl 39 in P16 wrt atom 1 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
37. holds_played2(A,B,[play1(C,D)|E]) :- \+terminates(play1(C,D),played2(A,B)), 
          happens(play1(C,D),E), holds(played2(A,B),E).
38. holds_played2(A,B,[play2(C,D)|E]) :- \+terminates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E), holds(played2(A,B),E).

P18: by deleting cl 37 in P17

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
38. holds_played2(A,B,[play2(C,D)|E]) :- \+terminates(play2(C,D),played2(A,B)), 
          happens(play2(C,D),E), holds(played2(A,B),E).

P19: by deleting goal [1] in cl 38 in P18

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
41. holds_played2(A,B,[play2(C,D)|E]) :- happens(play2(C,D),E), 
          holds(played2(A,B),E).

P20: by unfolding cl 41 in P19 wrt atom 1 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
42. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          holds(not(played2(C,D)),E), holds(played2(A,B),E).

P21: by unfolding cl 42 in P20 wrt atom 2 using P1

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
44. holds_played2(A,B,[play2(C,D),E|F]) :- holds(played1(C,D),[E|F]), 
          elem(not(played2(C,D))), event(E), initiates(E,not(played2(C,D))), 
          happens(E,F), holds(played2(A,B),[E|F]).
45. holds_played2(A,B,[play2(C,D),E|F]) :- holds(played1(C,D),[E|F]), 
          elem(not(played2(C,D))), event(E), \+terminates(E,not(played2(C,D))), 
          happens(E,F), holds(not(played2(C,D)),F), holds(played2(A,B),[E|F]).

P22: by deleting cl 44 in P21

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
45. holds_played2(A,B,[play2(C,D),E|F]) :- holds(played1(C,D),[E|F]), 
          elem(not(played2(C,D))), event(E), \+terminates(E,not(played2(C,D))), 
          happens(E,F), holds(not(played2(C,D)),F), holds(played2(A,B),[E|F]).

P23: by deleting cl 45 in P22

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).

P24: by adding def 46 to P23

30. holds_played2(A,B,[play2(A,B)|C]) :- holds(played1(A,B),C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P25: by folding cl 30 in P24 using cl 46

47. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P26: by replacing cl 47 by cl 48 in P25

48. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds(played2(A,B),C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P27: by replacing cl 48 by cl 49 in P26

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
40. holds_played2(A,B,[buy(C,D)|E]) :- holds(played2(A,B),E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P28: by folding cl 40 in P27 using cl 21

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
43. holds_played2(A,B,[play2(C,D)|E]) :- holds(played1(C,D),E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P29: by folding cl 43 in P28 using cl 46

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
51. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds(played2(C,D),E), holds(played2(A,B),E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P30: by folding cl 51 in P29 using cl 21

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
52. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds(played2(C,D),E), holds_played2(A,B,E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P31: by replacing cl 52 by cl 53 in P30

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
46. holds_played1(A,B,C) :- holds(played1(A,B),C).

P32: by unfolding cl 46 in P31 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
54. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          initiates(C,played1(A,B)), happens(C,D).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P33: by unfolding cl 54 in P32 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
56. holds_played1(A,B,[C|D]) :- event(C), initiates(C,played1(A,B)), 
          happens(C,D).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P34: by unfolding cl 56 in P33 wrt atom 2 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
57. holds_played1(A,B,[play1(A,B)|C]) :- event(play1(A,B)), 
          happens(play1(A,B),C).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P35: by unfolding cl 57 in P34 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
58. holds_played1(A,B,[play1(A,B)|C]) :- happens(play1(A,B),C).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P36: by unfolding cl 58 in P35 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
59. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          holds(not(played1(A,B)),C).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P37: by unfolding cl 59 in P36 wrt atom 2 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
60. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          \+holds(played1(A,B),C).
61. holds_played1(A,B,[play1(A,B),C|D]) :- holds(bought(A,B),[C|D]), 
          elem(not(played1(A,B))), event(C), initiates(C,not(played1(A,B))), 
          happens(C,D).
62. holds_played1(A,B,[play1(A,B),C|D]) :- holds(bought(A,B),[C|D]), 
          elem(not(played1(A,B))), event(C), \+terminates(C,not(played1(A,B))), 
          happens(C,D), holds(not(played1(A,B)),D).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P38: by deleting cl 61 in P37

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
60. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          \+holds(played1(A,B),C).
62. holds_played1(A,B,[play1(A,B),C|D]) :- holds(bought(A,B),[C|D]), 
          elem(not(played1(A,B))), event(C), \+terminates(C,not(played1(A,B))), 
          happens(C,D), holds(not(played1(A,B)),D).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P39: by deleting cl 62 in P38

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
60. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          \+holds(played1(A,B),C).
55. holds_played1(A,B,[C|D]) :- elem(played1(A,B)), event(C), 
          \+terminates(C,played1(A,B)), happens(C,D), holds(played1(A,B),D).

P40: by unfolding cl 55 in P39 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
60. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          \+holds(played1(A,B),C).
63. holds_played1(A,B,[C|D]) :- event(C), \+terminates(C,played1(A,B)), 
          happens(C,D), holds(played1(A,B),D).

P41: by unfolding cl 63 in P40 wrt atom 1 using P1

49. holds_played2(A,B,[play2(A,B)|C]) :- holds_played1(A,B,C), 
          \+holds_played2(A,B,C).
50. holds_played2(A,B,[buy(C,D)|E]) :- holds_played2(A,B,E).
53. holds_played2(A,B,[play2(C,D)|E]) :- holds_played1(C,D,E), 
          \+holds_played2(C,D,E), holds_played2(A,B,E).
60. holds_played1(A,B,[play1(A,B)|C]) :- holds(bought(A,B),C), 
          \+holds(played1(A,B),C).
64. holds_played1(A,B,[buy(C,D)|E]) :- \+terminates(buy(C,D),played1(A,B)), 
          happens(buy(C,D),E), holds(played1(A,B),E).
65. holds_played1(A,B,[play1(C,D)|E]) :- \+terminates(play1(C,D),played1(A,B)), 
          happens(play1(C,D),E), holds(played1(A,B),E).
66. holds_played1(A,B,[play2(C,D)|E]) :- \+terminates(play2(C,D),played1(A,B)), 
          happens(play2(C,D),E), holds(played1(A,B),E).

