% YSP [Kowalski Fest. 2002]

holds(alive,[]).
holds(loaded,[load|S]).
holds(dead,[shoot|S]) :- holds(loaded,S).
holds(F,[E|S]) :- fact(F), event(E), holds(F,S), \+ab(F,E,S).
ab(alive,shoot,S) :- holds(loaded,S).
event(load).
event(shoot).
event(wait).
fact(alive).
fact(dead).
fact(loaded).

app([],Y,Y).
app([A|X],Y,[A|Z]) :- app(X,Y,Z).


f :- \+g.
g :- holds(dead,S), \+h(S).
h(S) :-  app(S1,[shoot|S2],S4), app(S4,[load|S3],S).