%ks(ToysRoom, FunMin, SizeBag, ToysBag) :-
%    toysroom(ToysRoom),
%    subsettoys(ToysBag,ToysRoom,FunToysBag,SizeToysBag),
%    FunToysBag >= FunMin,
%    SizeToysBag =< SizeBag.

%subsettoys([Toy|ToysBag],[Toy|ToysRoom],FunToysBag,SizeToysBag) :-
%    toy(Toy,(F,S)),
%    subsettoys(ToysBag,ToysRoom,FunToysBag_1,SizeToysBag_1),
%    FunToysBag is FunToysBag_1 + F,
%    SizeToysBag is SizeToysBag_1 + S.
%subsettoys(ToysBag,[_|ToysRoom],FunToysBag,SizeToysBag) :-
%    subsettoys(ToysBag,ToysRoom,FunToysBag,SizeToysBag).
%subsettoys([],[],0,0).

%toysroom(L) :- setof(Toy, X^toy(Toy,X), L).

subsettoys2([Toy|ToysBag],[Toy|ToysRoom],SizeToysBag) :-
    toy(Toy,S),
    subsettoys2(ToysBag,ToysRoom,SizeToysBag_1),
    SizeToysBag is SizeToysBag_1 + S.
subsettoys2(ToysBag,[_|ToysRoom],SizeToysBag) :-
    subsettoys2(ToysBag,ToysRoom,SizeToysBag).
subsettoys2([],[],0).


ks2(ToysRoom, ToysBag) :-
    subsettoys2(ToysBag,ToysRoom,10).

