% Derived from not_parse 

not_parse(A) :- word(A), \+parse([s],A).
word([]).
word([A|B]) :- terminal(A), word(B).
parse([],[]).
parse([A|B],[A|C]) :- terminal(A), parse(B,C).
parse([A|B],C) :- nonterminal(A), production(A,D), app(D,B,E), parse(E,C).
app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).
terminal(a).
terminal(b).
nonterminal(s).
nonterminal(x).
production(s,[a,x,b]).
production(x,[]).
production(x,[a,x]).
production(x,[a,b,x]).
new1([a|A]) :- new2(A).
new2([b|A]) :- new3(A).
new2([a|A]) :- new4(A).
new3([]).
new4([b|A]) :- new5(A).
new4([a|A]) :- new4(A).
new5([]).
new5([b|A]) :- new3(A).
new5([a|A]) :- new4(A).
