reducible(T,X) :- canonical(T,X).
reducible(T,X) :- X=:=X1+1, transform(T,T1,X), reducible(T1,X1).
canonical([],X).
canonical([b|T],X) :- X=:=X1+1, canonical(T,X1).
edge(a,b).
edge(b,b).
transform([],[],X).
transform([H|T],[H1|T1],X) :- X=:=X1+1, edge(H,H1), transform(T,T1,X1).
generate(0,[a],X).
generate(s(N),[b|T],X) :- X=:=X1+1, generate(N,T,X1).
spec_red(T,X) :- reducible([b|T],X).
theorem(N,X) :- X=:=X1+X2, generate(N,L,X1), reducible(L,X2).
X=:=X.
