reducible(T,X) :- canonical(T,X1).
reducible(T,X) :- X>X2, transform(T,T1,X1), reducible(T1,X2).
canonical([],X).
canonical([b|T],X) :- X>X1, canonical(T,X1).
edge(a,b,X).
edge(b,b,X).
transform([],[],X).
transform([H|T],[H1|T1],X) :- X>X2, edge(H,H1,X1), transform(T,T1,X2).
generate(0,[a],X).
generate(s(N),[b|T],X) :- X>X1, generate(N,T,X1).
spec_red(T,X) :- reducible([b|T],X).
theorem(N,X) :- X>=X1, X>=X2, generate(N,L,X1), reducible(L,X2).