reducible(T,X) :- X>=X1+1, canonical(T,X1).
reducible(T,X) :- X>=X1+X2+1, transform(T,T1,X1), reducible(T1,X2).
canonical([],0).
canonical([b|T],X) :- X>=X1+1, canonical(T,X1).
edge(a,b,0).
edge(b,b,0).
transform([],[],0).
transform([H|T],[H1|T1],X) :- X>=X1+X2+1, edge(H,H1,X1), transform(T,T1,X2).
generate(0,[a],0).
generate(s(N),[b|T],X) :- X>=X1+1, generate(N,T,X1).
spec_red(T,X) :- X>=X1+1, reducible([b|T],X1).
theorem(N,X) :- X>=X1+X2+1, generate(N,L,X1), reducible(L,X2).
