sat(X,pos) :- X>=0.

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- sat(S+1,ef(X)).

formula(F) :- elementary(F).
formula(not(F)) :- formula(F).
formula(and(F1,F2)) :- formula(F1), formula(F2).
formula(ef(F)) :- formula(F).

elementary(pos).

sat_ag(S,F) :- formula(F), \+ sat(S,ef(not(F))).
