%Transitions

t(s(X), s(Y)) :- X>0, Y=:=X.
t(s(X), s(Y)) :- Y=:=X+1.

ts(s(X),[s(Y)]) :-  X=<0, Y=:=X+1.
ts(s(X),[s(Y1),s(Y2)]) :-  X>0, Y1=:=X, Y2=:=X+1.


%Elementary Properties

elem(s(X),initial) :- X=<0.

elem(s(X),neg) :- X<0.
elem(s(X),pos) :- X>0.



%Temporal Properties

prop1 :- prop(ef(eg(pos))).		%unknown
prop2 :- prop(ef(not(af(neg)))).		%unknown
prop3 :- prop(ef(pos)).


