%Transitions

t(s(X,Y),s(X1,Y1)) :- X>=1, X1=:=0, Y1=:=Y+1.
t(s(X,Y),s(X1,Y1)) :- Y>=1, X1=:=X+2, Y1=:=Y-1.

ts(s(X,Y),[s(X1,Y1),s(X2,Y2)]) :-
	X>=1, Y>=1,
	X1=:=0, Y1=:=Y+1,
	X2=:=X+2, Y2=:=Y-1.
ts(s(X,Y),[s(X1,Y1)]) :-
	X>=1, Y<1,
	X1=:=0, Y1=:=Y+1.
ts(s(X,Y),[s(X2,Y2)]) :-
	X<1, Y>=1,
	X2=:=X+2, Y2=:=Y-1.


%Elementary Properties

elem(s(X,Y),initial) :- X=:=1, Y=:=0.
elem(s(X,Y),p) :- X=:=3, Y=:=0.
elem(s(X,Y),p3) :- X=:=3.


%Temporal Properties

prop :- prop(ef(p)).
prop2 :- prop(not(ef(p3))).
prop3 :- prop(af(p3)).
