% Transitions

t(s(I,V,D),s(I,V,D)) :-
	I>=0,V>=0,D>=1.

t(s(I,V,D),s(I,V,D)) :-
	I>=0,D>=0,V>=1.

t(s(I,V,D),s(I1,V1,D1)) :-
	I>=1,D>=0,V>=0,I1=:=I+D-1,V1=:=V+1,D1=:=0.

t(s(I,V,D),s(I1,V1,D1)) :-
	D>=0,V>=1,I>=0,D1=:=1,I1=:=I+D+V-1,V1=:=0.

t(s(I,V,D),s(I1,V1,D1)) :-
	D>=0,V>=0,I>=1,D1=:=1,I1=:=I+D+V-1,V1=:=0.



% Elementary Properties

elem(s(I,V,D),initial) :- I>=0,V=:=0,D=:=0.
elem(s(I,V,D),unsafe1) :- I>=0, V>=1, D>=1.
elem(s(I,V,D),unsafe2) :- I>=0, V>=0, D>=2.


% Temporal Properties

safe1 :- prop(not(ef(unsafe1))).
safe2 :- prop(not(ef(unsafe2))).

%safe1 :- I>=0,V=:=0,D=:=0, sat(s(I,V,D),not(ef(el_unsafe1))).
