sat(s(A,P1,P2,C1,C2,S),el_unsafe) :- P1+P2-(C1+C2)+A>=S+1.
sat(s(A,P1,P2,C1,C2,S),el_unsafe) :- P1+P2-(C1+C2)+A=<S-1.

sat(s(A,P1,P2,C1,C2,S),el_safe2) :- P1+P2-(C1+C2)=:=S-A.
sat(s(A,P1,P2,C1,C2,S),el_safe3) :- 0=<P1+P2-(C1+C2), P1+P2-(C1+C2)=<S.
sat(s(A,P1,P2,C1,C2,S),el_safe4) :- 0=<A, A=<S.

%sat(A,or(B,C)) :- sat(A,B).
%sat(A,or(B,C)) :- sat(A,C).
%sat(A,and(B,C)) :- sat(A,B), sat(A,C).
sat(A,not(B)) :- \+sat(A,B).

sat(S,ef(B)) :- sat(S,B).

sat(s(A,P1,P2,C1,C2,S),ef(G)) :- A>=1, A1=:=A-1, P11=:=P1+1, sat(s(A1,P11,P2,C1,C2,S),ef(G)).
sat(s(A,P1,P2,C1,C2,S),ef(G)) :- A>=1, A1=:=A-1, P21=:=P2+1, sat(s(A1,P1,P21,C1,C2,S),ef(G)).
sat(s(A,P1,P2,C1,C2,S),ef(G)) :- A=<S-1, A1=:=A+1, C11=:=C1+1, sat(s(A1,P1,P2,C11,C2,S),ef(G)).
sat(s(A,P1,P2,C1,C2,S),ef(G)) :- A=<S-1, A1=:=A+1, C21=:=C2+1, sat(s(A1,P1,P2,C1,C21,S),ef(G)).

safe :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),not(ef(el_unsafe))).
unsafe :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),ef(el_unsafe)).

safe2 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),not(ef(not(el_safe2)))).
unsafe2 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),ef(not(el_safe2))).

safe3 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),not(ef(not(el_safe3)))).
unsafe3 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),ef(not(el_safe3))).

safe4 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),not(ef(not(el_safe4)))).
unsafe4 :- A=:=S,P1=:=0,P2=:=0,C1=:=0,C2=:=0, S>=1, sat(s(A,P1,P2,C1,C2,S),ef(not(el_safe4))).



