m(0,[y|Bs]).
m(s(X),[B|Bs]) :- m(X,Bs).

leq(0,X).
leq(s(X),s(Y)) :- leq(X,Y).

eq_set([],[]).
eq_set([],[n|Ys]) :- emptyset(Ys).
eq_set([n|Xs],[]) :- emptyset(Xs).
eq_set([X|Xs],[Y|Ys]) :- eq_bit(X,Y), eq_set(Xs,Ys).
%eq_set([y|Xs],[y|Ys]) :- eq_set(Xs,Ys).
%eq_set([n|Xs],[n|Ys]) :- eq_set(Xs,Ys).


eq_nat(0,0).
eq_nat(s(X),s(Y)) :- eq_nat(X,Y).

eq_bit(n,n).
eq_bit(y,y).

emptyset([]).
emptyset([n|Xs]) :- emptyset(Xs).

%delete(Xs,X,Ys) iff Ys = Xs-{X}
delete([y|Xs],0,[]) :- emptyset(Xs).
delete([y|Xs],0,[n|Ys]) :- emptyset(Xs), emptyset(Ys).
delete([X|Xs],s(N),[Y|Ys]) :- eq_bit(X,Y), delete(Xs,N,Ys).

%TYPE DEFINITIONS

bit(n).
bit(y).

set([]).
set([n|Bs]) :- set(Bs).
set([y|Bs]) :- set(Bs).

nat(0).
nat(s(X)) :- nat(X).



%TYPE DECLARATIONS

type(m,2,[nat,set]).

type(leq,2,[nat,nat]).

type(eq_set,2,[set,set]).

type(eq_nat,2,[nat,nat]).

type(eq_bit,2,[bit,bit]).

type(emptyset,1,[set]).

type(delete,3,[set,nat,set]).

