% TPLP Running Example [FPP 2007]
% MAP code
% Nov 2007

%Transitions

t(s(a,X), s(a,Y)) :- Y=:=X+2.
t(s(a,X), s(b,X)) :- X>0.
t(s(b,X), s(b,Y)) :- Y=:=X+1.

ts(s(a,X),[s(a,Y)]) :-  X=<0, Y=:=X+2.
ts(s(a,X),[s(a,Y),s(b,X)]) :-  X>0, Y=:=X+2.
ts(s(b,X),[s(b,Y)]) :- Y=:=X+1.


%Elementary Properties

elem(s(a,X),initial) :- X=:=0.
%elem(s(a,X),initial) :- X=:=0.
%elem(s(a,X),minus1) :- X=:= (-1).
%elem(s(a,X),minus5) :- X=:= (-5).

elem(s(_,X),neg) :- X<0.
%elem(s(_,X),geq0) :- X =< (-1).


%Temporal Properties

vclprop :- \+ negprop.
negprop :- sat(s(C,X),and(initial,af(neg))).

%vclprop :- prop(not(af(neg))).
%prop :- prop(ef(not(af(neg)))).				%true
%p1 :- exists_state(and(zero,not(ef(not(geq0))))).	%false
%p2 :- exists_state(and(minus1,ef(not(ef(geq0))))).	%true
%p3 :- exists_state(and(minus5,ef(not(ef(geq0))))).	%true
%p5 :- exists_state(and(zero,af(not(ef(not(geq0)))))).	%false
%p6 :- \+ exists_state(and(zero,not(ef(not(geq0))))).	%false

