%Commutativity of +

prop :- \+ negprop.

negprop :- p(X,Y,Z), notp(Y,X,Z).

notp(X,Y,Z) :- \+ p(X,Y,Z).

p(0,Y,Z) :- eq(Y,Z).
p(s(X),Y,s(Z)) :- p(X,Y,Z).

eq(X,X).

%eq(0,0).
%eq(s(X),s(Y)) :- eq(X,Y).

nat(0).
nat(s(X)) :- nat(X).

kthsucc(K,0,K).
kthsucc(K,s(X),s(N)) :- kthsucc(K,X,N).