--- Specialized Buy_example1 ---

holds_played2([play2|A]) :- holds_played1(A), \+ holds_played2(A).
holds_played2([buy|A]) :- holds_played2(A).
holds_played1([play1|A]) :- holds_bought(A), \+ holds_played1(A).
holds_played1([play2|A]) :- \+ holds_played2(A), holds_played1(A).
holds_bought([buy|A]).
holds_bought([play1|A]) :- holds_bought(A), \+ holds_played1(A).

1. holds_p1_np2(A) :- holds_played1(A), \+ holds_played2(A).
2. holds_b_np1(A) :- holds_bought(A), \+ holds_played1(A).

----- 1 -----
u.
holds_p1_np2([play1|A]) :- holds_bought(A), \+ holds_played1(A), \+ holds_played2([play1|A]).
holds_p1_np2([play2|A]) :- \+ holds_played2(A), holds_played1(A), \+ holds_played2([play2|A]).

u.
holds_p1_np2([play1|A]) :- holds_bought(A), \+ holds_played1(A).
holds_p1_np2([play2|A]) :- \+ holds_played2(A), holds_played1(A), \+ holds_played1(A). %delete
holds_p1_np2([play2|A]) :- \+ holds_played2(A), holds_played1(A), holds_played2(A). %delete

f.
holds_p1_np2([play1|A]) :- holds_b_np1(A).


----- 2 -----
u.
holds_b_np1([buy|A]) :- \+ holds_played1([buy|A]).
holds_b_np1([play1|A]) :- holds_bought(A), \+ holds_played1(A), \+ holds_played1([play1|A]).

u.
holds_b_np1([buy|A]).
holds_b_np1([play1|A]) :- holds_bought(A), \+ holds_played1(A), \+ holds_bought(A). %delete
holds_b_np1([play1|A]) :- holds_bought(A), \+ holds_played1(A), holds_played1(A). %delete


------ final definite program ------

holds_played2([play2|A]) :- holds_p1_np2(A).
holds_played2([buy|A]) :- holds_played2(A).
holds_played1([play1|A]) :- holds_b_np1(A).
holds_played1([play2|A]) :- holds_p1_np2(A).
holds_bought([buy|A]).
holds_bought([play1|A]) :- holds_b_np1(A).

holds_p1_np2([play1|A]) :- holds_b_np1(A).
holds_b_np1([buy|A]).

