%--- Specialized Buy_example ---

holds_played2([play2|A]) :- holds_played1(A), \+ holds_played2(A).
holds_played2([buy|A]) :- holds_played2(A).
holds_played1([play1|A]) :- holds_bought(A), \+ holds_played1(A).
holds_played1([play2|A]) :- \+ holds_played2(A), holds_played1(A).
holds_bought([buy|A]).
holds_bought([play1|A]) :- holds_bought(A), \+ holds_played1(A).

%TYPE DECLARATIONS

type(holds_played2,1,[list_of_events]).
type(holds_played1,1,[list_of_events]).
type(holds_bought,1,[list_of_events]).

event(buy).
event(play1).
event(play2).
list_of_events([]).
list_of_events([H|T]) :- event(H), list_of_events(T).


% :- synth(hp2(P), holds_played2(P)).

/*
%Synthesized Definite Program: 
hp2([play2|A]) :- new1(A).
hp2([buy|A]) :- hp2(A).
new1([play1|A]) :- new2(A).
new2([buy|A]).
*/

