queens(A,B) :- perm(A,C), pair(A,C,B), safe([],B).
perm([],[]).
perm([A|B],[C|D]) :- del(C,[A|B],E), perm(E,D).
del(A,[A|B],B).
del(A,[B|C],[B|D]) :- del(A,C,D).
pair([],[],[]).
pair([A|B],[C|D],[p(A,C)|E]) :- pair(B,D,E).
safe(A,[]).
safe(A,[B|C]) :- test(A,B), safe([B|A],C).
test([],A).
test([A|B],C) :- ndiag(A,C), test(B,C).
ndiag(p(A,B),p(C,D)) :- A-C=\=B-D, A-C=\=D-B.
