parse(G,[A],[A|X]-X) :- terminal(A).
parse(G,[A],W) :- nonterminal(A), member((A->Bs),G), parse(G,Bs,W).
parse(G,[A1,A2|As],W-X) :- parse(G,[A1],W-I), parse(G,[A2|As],I-X).
member(A,[A|X]).
member(A,[B|X]) :- member(A,X).
terminal(0).
terminal(1).
nonterminal(s).
nonterminal(u).
nonterminal(v).
nonterminal(w).

sp_parse(W) :- parse([(s->[0,u]), (s->[0,v]), (s->[0,w]), (u->[0]),
		(u->[0,u]), (u->[0,v]), (v->[0]), (v->[0,v]),
 		(v->[0,u]), (w->[1]), (w->[0,w])], [s],W-[]).

