% UNFOLD/FOLD PROOF FOR LAW 1 INSERTION SORT

new1(A,Y,Z) :- insert(A,Y,Z),ordered(Z).		% w(1)

new2(A,Y,Z) :- ordered(Y),op_insert(A,Y,Z).		% w(2)

p.							% dummy
q.							% dummy

insert(A,X,[A|X]) :- list(X).				% w(4)
insert(A,[B|X],[B|Y]) :- insert(A,X,Y).			% w(5)

op_insert(A,[],[A]).					% w(6)
op_insert(A,[B|X],[A,B|X]) :- A=<B.			% w(7)
op_insert(A,[B|X],[B|Y]) :- A>=B, op_insert(A,X,Y).	% w(8)

ordered([]).						% w(9)
ordered([_]).						% w(10)
ordered([X,Y|L]) :- X =<Y, ordered([Y|L]).		% w(11)

list([]).						% w(12)
list([_|T]) :- list(T).					% w(13)

% LAW 1:
law(([list(C),ordered([B|C])],[ordered([B|C])]),(u(2)-u(1)),[(u(1)+w(12))>=u(2),w(11)>=1,(w(11)+w(13))>=1,(u(1)+w(10)+w(12))>=1,(u(2)+w(10))>=1]).
