%
% LAW8 :
%
% frontierlist([T1,T2|TL],[L1,L2|LL]) and flatten([L1,L2|LL],L)
%
%  =={T1,T2,TL,L}==>
%
% frontierlist([T1,T2|TL],M) and flatten(M,L)

frontier(tree(T1,T2),L) :- frontier(T1,L1), frontier(T2,L2), append(L1,L2,L).	% W1
frontier(tip(A),[A]).								% W2

frontierlist([],[]).								% W3
frontierlist([T|TL],[L|LL]) :- frontier(T,L), frontierlist(TL,LL).		% W4

flatten([],[]).									% W5
flatten([L|LL],N) :- flatten(LL,M), append(L,M,N).				% W6

append([],L,L).									% W7
append([H|T],L,[H|S]) :- append(T,L,S).						% W8

new1(T1,T2,TL,L) :- frontierlist([T1,T2|TL],[L1,L2|LL]), flatten([L1,L2|LL],L).	% W9-U15
new2(T1,T2,TL,L) :- frontierlist([T1,T2|TL],M), flatten(M,L).			% W10-U16

% COMPUTED CONSTRAINT
%
% {A1>=1,Wx>=1,Wy>=1,(U3+A1)>=1,Wx>=Wy,U3=<0, Wy=<A2,A2>=0}
