reducible(T,X) :- X>=X1, canonical(T,X1).
reducible(T,X) :- X>=X1, X>X2, transform(T,T1,X1), reducible(T1,X2).
canonical([],X).
canonical([b|T],X) :- X>X1, canonical(T,X1).
edge(a,b).
edge(b,b).
transform([],[],X).
transform([H|T],[H1|T1],X) :- X>X1, edge(H,H1), transform(T,T1,X1).
generate(0,[a],X).
generate(s(N),[b|T],X) :- X>X1, generate(N,T,X1).
spec_red(T,X) :- X>=X1, reducible([b|T],X1).
theorem(N,X) :- X>=X1, X>=X2, generate(N,L,X1), reducible(L,X2).
