% taken from Delzanno CAV2000

%sat(s(I,D,S,E),el_unsafe1) :- D>=3.
%sat(s(I,D,S,E),el_unsafe2) :- D>=2,S>=2.

%sat(s(I,D,S,E),el_safe) :- D=<1.
%sat(s(I,D,S,E),el_safe) :- D=<2, S=<1.

sat(s(I,D,S,E), not(ef(el_unsafe2))) :- \+ sat(s(I,D,S,E), ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :- D>=2,S>=2.

%========== D=<1, S>=2

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=0,D>=0,S>=0,E>=0,D+S+E>=1,
	sat(s(I,D,S,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=1,D>=0,S>=1,E>=0,
	I1=:=I-1,S1=:=S+1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=1,D>=1,S>=0,E>=0,
	I1=:=I-1,D1=:=D-1,S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=1,D=:=0,S=:=0,E>=0,
	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=0,D>=0,S>=0,E>=0, D+S+E>=1,
	D1=:=1,E1=:=0,I1=:=I+E+D+S-1,S1=:=0,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=1,D>=0,S>=0,E>=0,
	I1=:=E+D+I+S-1,E1=:=0,S1=:=0,D1=:=1,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=0,D>=1,S>=0,E>=0,
	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,S,E),ef(el_unsafe2)).


sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,S1=:=S-1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S>=2,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).

%==========D=<1, S=<1,

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=0,D>=0,S>=0,E>=0,D+S+E>=1,
	sat(s(I,D,S,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=1,D>=0,S>=1,E>=0,
	I1=:=I-1,S1=:=S+1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=1,D>=1,S>=0,E>=0,
	I1=:=I-1,D1=:=D-1,S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=1,D=:=0,S=:=0,E>=0,
	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=0,D>=0,S>=0,E>=0, D+S+E>=1,
	D1=:=1,E1=:=0,I1=:=I+E+D+S-1,S1=:=0,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=1,D>=0,S>=0,E>=0,
	I1=:=E+D+I+S-1,E1=:=0,S1=:=0,D1=:=1,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=0,D>=1,S>=0,E>=0,
	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,S,E),ef(el_unsafe2)).


sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,S1=:=S-1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D=<1, S=<1,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).

%========== D>=2, S=<1

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=0,D>=0,S>=0,E>=0,D+S+E>=1,
	sat(s(I,D,S,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=1,D>=0,S>=1,E>=0,
	I1=:=I-1,S1=:=S+1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=1,D>=1,S>=0,E>=0,
	I1=:=I-1,D1=:=D-1,S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=1,D=:=0,S=:=0,E>=0,
	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=0,D>=0,S>=0,E>=0, D+S+E>=1,
	D1=:=1,E1=:=0,I1=:=I+E+D+S-1,S1=:=0,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=1,D>=0,S>=0,E>=0,
	I1=:=E+D+I+S-1,E1=:=0,S1=:=0,D1=:=1,
	sat(s(I1,D1,S1,E1),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=0,D>=1,S>=0,E>=0,
	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,S,E),ef(el_unsafe2)).


sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,S1=:=S-1,
	sat(s(I1,D,S1,E),ef(el_unsafe2)).

sat(s(I,D,S,E),ef(el_unsafe2)) :-
	D>=2, S=<1,
	I>=0,D>=0,S>=0,E>=0,
	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,S,E1),ef(el_unsafe2)).


safe :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(not(el_safe)))).
unsafe :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),ef(not(el_safe))).

safe1 :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(el_unsafe1))).
unsafe1 :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),ef(el_unsafe1)).

safe2 :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(el_unsafe2))).
unsafe2 :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),ef(el_unsafe2)).

