% taken from Delzanno CAV2000

%sat(s(_,_,_,M),el_unsafe1) :- M>=2.
%sat(s(_,S,_,M),el_unsafe2) :- M>=1,S>=1.

sat(S, not(P)) :- \+ sat(S, P).

sat(s(_,_,_,M),ef(el_unsafe1)) :- M>=2.

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
	I>=0,S>=0,M>=0,E>=0, S+M+E>=1,
	sat(s(I,S,E,M),ef(P)).

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
	I>=1,S>=0,E>=0,M>=0,
	I1=:=I-1,
	S1=:=S+M+E+1,
	E1=:=0,
	M1=:=0,
	sat(s(I1,S1,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
	M>=1,I>=0,E>=0,S>=0,
	sat(s(I,S,E,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
  	I>=0,S>=0,M>=0,E>=1,
  	E1=:=E-1,M1=:=M+1,
  	sat(s(I,S,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :- 
	M=<1,
   	I+S>=1, I>=0,S>=0,E>=0,M>=0,
	I1=:=I+S+E+M-1,S1=:=0,E1=:=1,M1=:=0,
	sat(s(I1,S1,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
	I>=0,S>=0,M>=0,E>=1,
	E1=:=E-1,I1=:=I+1,
	sat(s(I1,S,E1,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
    	I>=0,S>=1,M>=0,E>=0,
	S1=:=S-1,I1=:=I+1,
	sat(s(I1,S1,E,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M=<1,
    	I>=0,S>=0,M>=1,E>=0,
	M1=:=M-1,I1=:=I+1,
	sat(s(I1,S,E,M1),ef(P)).	


safe1 :- I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),not(ef(el_unsafe1))).
unsafe1 :- I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),ef(el_unsafe1)).

safe2 :- I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),not(ef(el_unsafe2))).
unsafe2 :- I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),ef(el_unsafe2)).

