t(0,1).
t(1,1).
t(0,2).
t(2,3).
t(3,2).

/*
t(X,Y) :- X=:=0, Y=:=1.
t(X,Y) :- X=:=1, Y=:=1.
t(X,Y) :- X=:=0, Y=:=2.
t(X,Y) :- X=:=2, Y=:=3.
t(X,Y) :- X=:=3, Y=:=2.
*/

p0 :- sat(0,P,e(f(e(g(geq2))))).  %true
p1 :- sat(2,P,e(g(geq2))).        %true
p2 :- sat(0,P,a(x(a(g(geq1))))).  %true


sat(2,P,geq2).
sat(3,P,geq2).
sat(1,P,geq1).
sat(2,P,geq1).
sat(3,P,geq1).

sat(S,P,or(F1,F2)) :- sat(S,P,F1).
sat(S,P,or(F1,F2)) :- sat(S,P,F2).

sat(S,P,and(F1, F2)) :-  sat(S,P,F1), sat(S,P,F2).
%sat(S,P,and(F1, F2)) :-  \+ sat(S,P,or(not(F1),not(F2))).

sat(S,P,not(F)) :- \+ sat(S,P,F).

sat(S,P1,e(F)) :- sat(S,P2,F).

sat(S1,[S2|P], x(F)) :- t(S1,S2), sat(S2,P,F).

sat(S,P,u(F1,F2)) :- sat(S,P,F2).
sat(S1,[S2|P], u(F1,F2)) :- t(S1,S2), sat(S1,[S2|P],F1), sat(S2,P,u(F1,F2)).



% Derived CTL* operators

sat(S,P,a(F)) :- \+ sat(S,P,e(not(F))).

sat(S,P,f(F)) :- sat(S,P,F).
sat(S1,[S2|P],f(F)) :- t(S1,S2), sat(S2,P,f(F)).

sat(S,P,g(F)) :- \+ sat(S,P,f(not(F))).

sat(S,P,r(F1,F2)) :- \+ sat(S,P,u(not(F1),not(F2))).


/*

% Derived CTL operators

sat(S1, ex(F)) :- t(S1,S2), sat(S2, F).

sat(S, ef(F)) :- sat(S,F).
sat(S1, ef(F)) :- t(S1,S2), sat(S2,ef(F)).

sat(S, eg(F)) :-  \+ sat([S|P],e(not(f(not(F))))).


p0 :- sat(0,ef(eg(geq2))).

p1 :- sat(2,eg(geq2)).


*/
