%Transitions

t(s(I,S,E,M),s(I,S,E,M)) :-
	I>=0,S>=0,M>=0,E>=0, S+M+E>=1.

t(s(I,S,E,M),s(I1,S1,E1,M1)) :-
	I>=1,S>=0,E>=0,M>=0,
	I1=:=I-1,
	S1=:=S+M+E+1,
	E1=:=0,
	M1=:=0.

t(s(I,S,E,M),s(I,S,E,M)) :-
	M>=1,I>=0,E>=0,S>=0.

t(s(I,S,E,M),s(I,S,E1,M1)) :-
  	I>=0,S>=0,M>=0,E>=1,
  	E1=:=E-1,M1=:=M+1.

t(s(I,S,E,M),s(I1,S1,E1,M1)) :-
   	I+S>=1, I>=0,S>=0,E>=0,M>=0,
	I1=:=I+S+E+M-1,S1=:=0,E1=:=1,M1=:=0.

t(s(I,S,E,M),s(I1,S,E1,M)) :-
	I>=0,S>=0,M>=0,E>=1,
	E1=:=E-1,I1=:=I+1.

t(s(I,S,E,M),s(I1,S1,E,M)) :-
    	I>=0,S>=1,M>=0,E>=0,
	S1=:=S-1,I1=:=I+1.

t(s(I,S,E,M),s(I1,S,E,M1)) :-
    	I>=0,S>=0,M>=1,E>=0,
	M1=:=M-1,I1=:=I+1.


%Elementary Propeties

elem(s(I,S,E,M),initial) :- I>=0,S=:=0,E=:=0,M=:=0.
elem(s(_,_,_,M),unsafe1) :- M>=2.
elem(s(_,S,_,M),unsafe2) :- M>=1,S>=1.


%Temporal Properties

safe1 :- prop(not(ef(unsafe1))).
safe2 :- prop(not(ef(unsafe2))).

