% Transitions

ts(s(0,X,Y),[s(1,XN,YN)]):- t(s(0,X,Y),s(1,XN,YN)).
ts(s(1,X,N),[s(0,XN,YN)]):- t(s(1,X,N),s(0,XN,YN)).

t(s(0,X,Y), s(1,XN,0)):-
		D>=0, XN=:=X+D, YN=:=Y+D, YN=<5, YN>=3.
t(s(1,X,Y), s(0,0,YN)):-
		D>=0, YN=:=Y+D, XN=:=X+D, YN=<10, XN=<8, YN>=4, XN>=6.


% Properties

p01:- sat(s(0,0,0),ef(safe)).       %true
p01n:- sat(s(0,0,0),not(ef(safe))).       %
p02:- sat(s(0,0,0),safe).           %true
p03:- sat(s(0,0,0),af(safe)).       %true
p04:- sat(s(0,0,0),ag(safe)).       %false unk
p05:- sat(s(0,3,5),ef(not(safe))).  %true - unkown
p05n:- sat(s(0,3,5),not(ef(not(safe)))).  %true - unkown
p051:- sat(s(0,0,5),ef(not(safe))). %true
p051n:- sat(s(0,0,5),not(ef(not(safe)))). %
p06:- sat(s(0,0,0),eg(safe)).       %false unk
p07:- sat(s(1,5,8),ex(not(safe))). %true

elem(s(0,X,Y),safe):- Y=<5.
elem(s(1,X,Y),safe):- Y=<10, X=<8.
