goodPath(P) :- path(P), \+ badPath(P).
badPath(P) :- has_a(P,R), \+ has_b(R).
has_a(P,R) :- is_a(A), concat(L,[A|R],P).
has_b(R) :- is_b(B), concat(S,[B|T],R).

path([]).
path([H|T]) :- path(T).

concat([],Y,Y).
concat([H|X],Y,[H|Z]) :- concat(X,Y,Z).
